VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "comdlg32.ocx"
Begin VB.Form Form1 
   Caption         =   "MostlyColor"
   ClientHeight    =   3195
   ClientLeft      =   165
   ClientTop       =   735
   ClientWidth     =   6870
   LinkTopic       =   "Form1"
   ScaleHeight     =   3195
   ScaleWidth      =   6870
   StartUpPosition =   3  'Windows Default
   Begin VB.PictureBox picConverted 
      Height          =   975
      Left            =   120
      ScaleHeight     =   915
      ScaleWidth      =   1155
      TabIndex        =   3
      Top             =   1320
      Visible         =   0   'False
      Width           =   1215
   End
   Begin VB.Frame fraOptions 
      Caption         =   "Options"
      Height          =   1095
      Left            =   0
      TabIndex        =   1
      Top             =   0
      Width           =   5295
      Begin VB.OptionButton optMostly 
         Caption         =   "Mostly Blue"
         Height          =   255
         Index           =   2
         Left            =   3120
         TabIndex        =   9
         Top             =   240
         Width           =   1215
      End
      Begin VB.OptionButton optMostly 
         Caption         =   "Mostly Green"
         Height          =   255
         Index           =   1
         Left            =   1680
         TabIndex        =   8
         Top             =   240
         Width           =   1335
      End
      Begin VB.OptionButton optMostly 
         Caption         =   "Mostly Red"
         Height          =   255
         Index           =   0
         Left            =   240
         TabIndex        =   7
         Top             =   240
         Width           =   1335
      End
      Begin VB.TextBox txtToColor 
         Height          =   285
         Left            =   1680
         TabIndex        =   5
         Text            =   "&HFFFFFF"
         Top             =   600
         Width           =   975
      End
      Begin VB.CommandButton cmdReset 
         Caption         =   "Reset"
         Height          =   375
         Left            =   4560
         TabIndex        =   4
         Top             =   660
         Width           =   615
      End
      Begin VB.CommandButton cmdGo 
         Caption         =   "Go"
         Enabled         =   0   'False
         Height          =   375
         Left            =   4560
         TabIndex        =   2
         Top             =   180
         Width           =   615
      End
      Begin VB.Label Label1 
         Caption         =   "Change to this color:"
         Height          =   255
         Index           =   1
         Left            =   120
         TabIndex        =   6
         Top             =   600
         Width           =   1575
      End
   End
   Begin VB.PictureBox picOriginal 
      Height          =   975
      Left            =   0
      ScaleHeight     =   915
      ScaleWidth      =   1155
      TabIndex        =   0
      Top             =   1200
      Visible         =   0   'False
      Width           =   1215
   End
   Begin MSComDlg.CommonDialog dlgFile 
      Left            =   3720
      Top             =   1200
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuFileOpen 
         Caption         =   "&Open"
         Shortcut        =   ^O
      End
      Begin VB.Menu mnuFileSaveAs 
         Caption         =   "Save &As..."
         Shortcut        =   ^A
      End
      Begin VB.Menu mnuFileExitSep 
         Caption         =   "-"
      End
      Begin VB.Menu mnuFileExit 
         Caption         =   "E&xit"
      End
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private m_FrameWidth As Single
Private Enum MostlyEnum
    mostly_Red
    mostly_Green
    mostly_Blue
    mostly_Tied
End Enum

Private m_SelectedMostly As MostlyEnum

Private Declare Function GetObject Lib "gdi32" Alias "GetObjectA" (ByVal hObject As Long, ByVal nCount As Long, lpObject As Any) As Long
Private Declare Function GetDIBits Lib "gdi32" (ByVal aHDC As Long, ByVal hBitmap As Long, ByVal nStartScan As Long, ByVal nNumScans As Long, lpBits As Any, lpBI As BITMAPINFO, ByVal wUsage As Long) As Long
Private Declare Function SetDIBits Lib "gdi32" (ByVal hdc As Long, ByVal hBitmap As Long, ByVal nStartScan As Long, ByVal nNumScans As Long, lpBits As Any, lpBI As BITMAPINFO, ByVal wUsage As Long) As Long
Private Type BITMAP '14 bytes
    bmType As Long
    bmWidth As Long
    bmHeight As Long
    bmWidthBytes As Long
    bmPlanes As Integer
    bmBitsPixel As Integer
    bmBits As Long
End Type
Private Type BITMAPINFOHEADER '40 bytes
    biSize As Long
    biWidth As Long
    biHeight As Long
    biPlanes As Integer
    biBitCount As Integer
    biCompression As Long
    biSizeImage As Long
    biXPelsPerMeter As Long
    biYPelsPerMeter As Long
    biClrUsed As Long
    biClrImportant As Long
End Type
Private Type RGBQUAD
    rgbBlue As Byte
    rgbGreen As Byte
    rgbRed As Byte
    rgbReserved As Byte
End Type
Private Type BITMAPINFO
    bmiHeader As BITMAPINFOHEADER
    bmiColors As RGBQUAD
End Type
Private Const DIB_RGB_COLORS = 0&
Private Const BI_RGB = 0&

Private Const pixR As Integer = 3
Private Const pixG As Integer = 2
Private Const pixB As Integer = 1
Private Function FilePath(ByVal file_name As String) As String
Dim pos As Integer

    pos = InStrRev(file_name, "\")
    FilePath = Left$(file_name, pos)
End Function

Private Sub TransformImage(ByVal from_picture As PictureBox, ByVal to_picture As PictureBox, ByVal to_color As OLE_COLOR, ByVal target_mostly As MostlyEnum)
Dim bitmap_info As BITMAPINFO
Dim pixels() As Byte
Dim bytes_per_scanLine As Integer
Dim pad_per_scanLine As Integer
Dim X As Integer
Dim Y As Integer
Dim pixel_mostly As MostlyEnum
Dim to_red As Byte
Dim to_green As Byte
Dim to_blue As Byte

    ' Prepare the bitmap description.
    With bitmap_info.bmiHeader
        .biSize = 40
        .biWidth = from_picture.ScaleWidth
        ' Use negative height to scan top-down.
        .biHeight = -from_picture.ScaleHeight
        .biPlanes = 1
        .biBitCount = 32
        .biCompression = BI_RGB
        bytes_per_scanLine = ((((.biWidth * .biBitCount) + _
            31) \ 32) * 4)
        pad_per_scanLine = bytes_per_scanLine - (((.biWidth _
            * .biBitCount) + 7) \ 8)
        .biSizeImage = bytes_per_scanLine * Abs(.biHeight)
    End With

    ' Load the bitmap's data.
    ReDim pixels(1 To 4, 1 To from_picture.ScaleWidth, 1 To _
        from_picture.ScaleHeight)
    GetDIBits from_picture.hdc, from_picture.Image, _
        0, from_picture.ScaleHeight, pixels(1, 1, 1), _
        bitmap_info, DIB_RGB_COLORS

    ' Get to_color's red, green, and blue components.
    UnRGB to_color, to_red, to_green, to_blue

    ' Modify the pixels.
    For Y = 1 To from_picture.ScaleHeight
        For X = 1 To from_picture.ScaleWidth
            ' See if this pixel is mostly
            ' red, green, or blue.
            If pixels(pixR, X, Y) > pixels(pixG, X, Y) And _
               pixels(pixR, X, Y) > pixels(pixB, X, Y) _
            Then
                pixel_mostly = mostly_Red
            ElseIf pixels(pixG, X, Y) > pixels(pixR, X, Y) And _
                   pixels(pixG, X, Y) > pixels(pixB, X, Y) _
            Then
                pixel_mostly = mostly_Green
            ElseIf pixels(pixB, X, Y) > pixels(pixR, X, Y) And _
                   pixels(pixB, X, Y) > pixels(pixG, X, Y) _
            Then
                pixel_mostly = mostly_Blue
            Else
                pixel_mostly = mostly_Tied
            End If

            ' See if this is the target color.
            If pixel_mostly = target_mostly Then
                pixels(pixR, X, Y) = to_red
                pixels(pixG, X, Y) = to_green
                pixels(pixB, X, Y) = to_blue
            End If
        Next X
    Next Y

    ' Display the result.
    SetDIBits to_picture.hdc, to_picture.Image, _
        0, to_picture.ScaleHeight, pixels(1, 1, 1), _
        bitmap_info, DIB_RGB_COLORS
    to_picture.Picture = to_picture.Image
End Sub
Private Sub UnRGB(ByRef color As OLE_COLOR, ByRef r As Byte, ByRef g As Byte, ByRef b As Byte)
    r = color And &HFF&
    g = (color And &HFF00&) \ &H100&
    b = (color And &HFF0000) \ &H10000
End Sub


Private Sub cmdGo_Click()
    TransformImage picOriginal, picConverted, _
        CLng(txtToColor.Text), m_SelectedMostly
    mnuFileSaveAs.Enabled = True

    picOriginal.Visible = False
    picConverted.Visible = True
End Sub

Private Sub cmdReset_Click()
    picOriginal.Visible = True
    picConverted.Visible = False
End Sub

Private Sub Form_Load()
    picOriginal.AutoRedraw = True
    picOriginal.AutoSize = True
    picOriginal.ScaleMode = vbPixels
    picConverted.AutoRedraw = True
    picConverted.AutoSize = True
    picConverted.Move picOriginal.Left, picOriginal.Top
    picConverted.ScaleMode = vbPixels

    m_FrameWidth = fraOptions.Width

    optMostly(0).value = True

    dlgFile.InitDir = App.Path
    dlgFile.Filter = _
        "Bitmap Files (*.bmp)|*.bmp|" & _
        "Graphic Files (*.bmp;*.gif;*.jpg;*.jpeg)|*.bmp;*.gif;*.jpg;*.jpeg|" & _
        "All Files (*.*)|*.*"
End Sub
Private Sub mnuFileExit_Click()
    Unload Me
End Sub


Private Sub mnuFileOpen_Click()
    ' Let the user select the file to open.
    dlgFile.Flags = _
        cdlOFNFileMustExist Or _
        cdlOFNLongNames Or _
        cdlOFNExplorer Or _
        cdlOFNHideReadOnly Or _
        cdlOFNNoReadOnlyReturn
    dlgFile.CancelError = True
    On Error Resume Next
    dlgFile.ShowOpen
    If Err.Number = cdlCancel Then
        Exit Sub
    ElseIf Err.Number <> 0 Then
        MsgBox "Error " & Err.Number & " selecting file" & _
            vbCrLf & Err.Description
        Exit Sub
    End If
    dlgFile.InitDir = FilePath(dlgFile.FileName)
    dlgFile.FileName = dlgFile.FileTitle

    ' Load the picture.
    picOriginal.Picture = LoadPicture(dlgFile.FileName)
    picOriginal.Visible = True
    picConverted.Visible = False
    picConverted.Width = picOriginal.Width
    picConverted.Height = picOriginal.Height
    mnuFileSaveAs.Enabled = False
    cmdGo.Enabled = True
    picConverted.Picture = picOriginal.Picture

    ' Size the form.
    If picOriginal.Left + picOriginal.Width > m_FrameWidth Then
        Width = picOriginal.Left + picOriginal.Width + Width - ScaleWidth
    Else
        Width = m_FrameWidth + Width - ScaleWidth
    End If
    Height = picOriginal.Top + picOriginal.Height + Height - ScaleHeight
    fraOptions.Width = ScaleWidth
End Sub

Private Sub mnuFileSaveAs_Click()
    dlgFile.Flags = _
        cdlOFNOverwritePrompt Or _
        cdlOFNLongNames Or _
        cdlOFNExplorer
    dlgFile.CancelError = True
    On Error Resume Next
    dlgFile.ShowSave
    If Err.Number = cdlCancel Then
        Exit Sub
    ElseIf Err.Number <> 0 Then
        MsgBox "Error " & Err.Number & " selecting file" & _
            vbCrLf & Err.Description
        Exit Sub
    End If
    dlgFile.InitDir = FilePath(dlgFile.FileName)
    dlgFile.FileName = dlgFile.FileTitle

    SavePicture picConverted.Picture, dlgFile.FileName
End Sub


Private Sub optMostly_Click(Index As Integer)
    m_SelectedMostly = Index
End Sub

Private Sub picOriginal_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    Me.Caption = "MostlyColor (&H" & Hex$(picOriginal.Point(X, Y)) & ")"
End Sub
